<?php

class DB_EventMapper {
	/**
	 * Vraci instanci objektu zbozi podle predaneho ID.
	 * @param integer $id
	 */
	public static function getInstanceById($id) {
	  	 $query = dibi::query("SELECT * FROM event WHERE event_id=%i LIMIT 1", $id);
	     if (count($query) == 0) return null;
	     else {
	        $res = $query->fetch();
	    	$inst = self::getInstanceFromResultRow($res);
	    	return $inst;
	     }
	}
	
	public static function getAll($orderLimit = 'ORDER BY event_id DESC', $where = '1') {
		$return = array();
		$query = dibi::query("SELECT * FROM event WHERE ".$where." ".$orderLimit);
		if (count($query) == 0) return $return;
		else {
			foreach ($query as $n => $res) {
				$return[] = self::getInstanceFromResultRow($res);
			}
			return $return;
		}
	}
	
	public function getAllEvents($login = null,$orderLimit = 'ORDER BY event_id DESC') {
		$udalosti = self::getAll($orderLimit);
		if ($login->opravneni != 1) {
			$return = array();
			foreach ($udalosti as $ev) {
				if (!$ev->isOnlyAdmin() && $ev->getObject()->getUzivatel() == $login->user->getId()) $return[] = $ev;
			}
			return $return;
		}
		else return $udalosti;
	}
	
	public static function findByObject($object, $orderLimit = 'ORDER BY event_id DESC') {
		$return = array();
		if (!is_object($object) || !get_class($object)) return $return;
		
		$query = dibi::query("SELECT * FROM event WHERE class = %s AND object_id = %i ".$orderLimit,get_class($object),$object->getId());
		if (count($query) == 0) return $return;
		else {
			foreach ($query as $n => $res) {
				$return[] = self::getInstanceFromResultRow($res);
			}
			return $return;
		}	
	}
	
	public static function findAllByClassName($class_name, $orderLimit = 'ORDER BY event_id DESC') {
		$return = array();
		$query = dibi::query("SELECT * FROM event WHERE class = %s ".$orderLimit,$class_name);
		if (count($query) == 0) return $return;
		else {
			foreach ($query as $n => $res) {
				$return[] = self::getInstanceFromResultRow($res);
			}
			return $return;
		}	
	}
	
	public static function insert(Event $obj) {	
		if ($obj->getId() == 0) {
			$id = dibi::query('SELECT max(event_id) FROM [event]')->fetchSingle() + 1;	
			if (!$id) $id = 1;
			$obj->setId($id);  
	    }  
	    $arr = array(
	       'event_id' => $obj->getId(),
	       'nazev' => $obj->getNazev(),
	       'class' => $obj->getTrida(),
	       'user_id' => ($obj->getUser() instanceof User ? $obj->getUser()->getId() : null),
	       'object_id' => $obj->getObjectId(),
	       'only_admin' => $obj->getOnlyAdmin()
	    );
	    dibi::query('INSERT INTO [event]', $arr);
		return $id;
	}
	
	public static function update(Event $obj) {
	    $arr = array(
	       'event_id' => $obj->getId(),
	       'nazev' => $obj->getNazev(),
	       'class' => $obj->getTrida(),
	       'user_id' => ($obj->getUser() instanceof User ? $obj->getUser()->getId() : null),
	       'object_id' => $obj->getObjectId(),
	       'only_admin' => $obj->getOnlyAdmin(),
	       'time' => $obj->getTime()
	    );
    	dibi::query('UPDATE `event` SET ', $arr, 'WHERE `event_id`=%i', $obj->getId());
	}
	
	public static function delete(Event $obj) {
    	dibi::query('DELETE FROM `event` WHERE `event_id`=%i', $obj->getId());
	}
	
	public static function getInstanceFromResultRow($res) {
		$inst = new Event($res['nazev'],$res['class'],$res['object_id'],$res['only_admin'],$res['time'],$res['event_id']);
		$inst->setUser(DB_UserMapper::getInstanceById($res['user_id']));
		return $inst;
	}
	

}
?>