<?php
class Event {

	private $id = 0;
	
	private $nazev;
	private $trida;
	private $objectId;
	private $onlyAdmin;
	private $time;
	private $user;
	

	function __construct($nazev, $trida, $objectId, $onlyAdmin, $time = 0, $id = 0) {
		$this->setId($id);
		$this->setNazev($nazev);
		$this->setTrida($trida);
		$this->setObjectId($objectId);
		$this->setOnlyAdmin($onlyAdmin);
		$this->setTime($time);
	}
	//////////////////////////////
	public static function make($nazev, $objekt = null, $onlyAdmin = 0) {
		if (!$onlyAdmin || $onlyAdmin == 0) $onlyAdmin = 0;
		else $onlyAdmin = 1;
		
		$trida = null;
		$objectId = null;
		if (is_object($objekt) && get_class($objekt)) {
			$trida = get_class($objekt);
			$objectId = $objekt->getId();
		}
		$event = new Event($nazev,$trida,$objectId,$onlyAdmin);
		
		$login = new Login();
		if ($login instanceof Login && $login->getUser() instanceof User)
			$event->setUser($login->getUser());
		
		DB_EventMapper::insert($event);
	}
	//////////////////////////////

	public function getId() {
		return $this->id;
	}
	public function setId($newVal) {
		$this->id = intval($newVal);
	}

	public function getNazev() {
		return $this->nazev;
	}
	public function setNazev($newVal) {
		$this->nazev = $newVal;
	}

	public function getTrida() {
		return $this->trida;
	}
	public function setTrida($newVal) {
		$this->trida = ($newVal);
	}

	public function getObjectId() {
		return $this->objectId;
	}
	public function setObjectId($newVal) {
		$this->objectId = intval($newVal);
	}
	
	public function isOnlyAdmin() {
		return ($this->onlyAdmin == 1 ? true : false);
	}
	public function getOnlyAdmin() {
		return $this->onlyAdmin;
	}
	public function setOnlyAdmin($newVal) {
		$this->onlyAdmin = $newVal;
	}
	public function getTime($formatted = false) {
		if ($formatted) {
			$time = strtotime($this->time);
			return date('d.m.Y H:i',$time);
		}
		return $this->time;
	}
	public function setTime($newVal) {
		$this->time = $newVal;
	}
	
	public function getUser() {
		return $this->user;
	}
	public function setUser($newVal) {
		$this->user = ($newVal);
	}
	
	public function getObject() {
		$nazevMapperu = 'DB_'.$this->getTrida().'Mapper';
		$object = call_user_func($nazevMapperu.'::getInstanceById', $this->getObjectId());
		if (get_class($object) == $this->getTrida()) return $object;
		else return new NullEventObject($this);
	}
	
	public function __toString() {
		return $this->getNazev();
	}

	public function __get($varName) {
		$methodName = "get".ucfirst($varName);
		return call_user_func(array($this, $methodName));
	}

}
?>