<?php

class FakturaPdf extends FPDF {

	protected $faktura;

	// Hlavika strnky
	function Header() {
		//hlavni ramecek
	    $this->SetXY(10, 11);
	    $this->Cell(190, 265, "", 1);

		//zahlavi		
	    $this->SetFont('arialbd', '', '12');
	    $this->SetXY(10, 3.8);
	    //$pdf->Image("icon.gif", 13, 3.7);
	    $this->Cell(100, 9, "", 0, 0,"L");  // napr. Nazev FIRMY
		$nadpis = (iconv('utf-8', 'windows-1250', mb_strtoupper($this->getFaktura()->getTypNazev(),'utf-8')));
		if ($this->getFaktura()->getZaplacena()==2) {
			$nadpis = "STORNO ".$nadpis;
    		$this->SetTextColor(255,0,0);
		}
		if ($this->PageNo() > 1) {
			$nadpis .= " .".$this->getFaktura()->getCisloFaktury();
		}
	    $this->Cell(90, 9, $nadpis, 0, 0,"R");
	    	
		$this->SetTextColor(0,0,0);
	    $this->SetXY(10, 12);
	}

	// Patika strnky
	function Footer() {
	    // Pozice 1.5 cm od spodn hrany strnky
	    $this->SetY(-18);
	    // Arial italic 8
	    $this->SetFont('arial','I',8);
	    // slo strnky
	    $this->Cell(0,10,'Strana '.$this->PageNo().'/{nb}',0,0,'R');
	    $this->SetY(-18);
	    $this->SetFont('arial','',6);
	    $this->Cell(0,10,'Vystavil fakturan systm TripleWeb.cz.',0,0,'L');	    
	}
	
	
	public function writePolozkyPlatce() {
		 
		$hlavickaKusy = false;   
		foreach ($this->getFaktura()->getPolozky() as $pol) {  
			if ($pol->getKs() != 0 && !is_null($pol->getKs())) {
				$hlavickaKusy = true;
				break;
			}
		}   
		
		//polozky faktury
		//hlavicka
		    $this->Cell(3,8,"",TB,0,'L');
		    $this->SetFont('arialbd', '', '6.5');
		    $this->Cell(65,8,"Poloky",TB,0,'L');
		    $this->Cell(20,8,"",TB,0,'L');        
		    $this->Cell(25,8,$hlavickaKusy ? "Jedn.cena bez DPH" : "",TB,0,'L'); 
		    $this->Cell(14,8,$hlavickaKusy ? "Poet MJ  " : "",TB,0,'C'); 
		    $this->Cell(26,8,"Celk.cena bez DPH",TB,0,'L'); 
		    $this->Cell(10,8,"DPH %",TB,0,'C'); 
		    $this->Cell(27,8,"Celk.cena v. DPH",TB,1,'C'); 
		    $this->Cell(190,3,"",0,1,'L');
		
		//data
		    $this->SetFont('arial', '', '7');	
			foreach ($this->getFaktura()->getPolozky() as $pol) {  
			    $this->Cell(3,3,"",0,0,'L');
			    $polozka = $pol->getPolozka()->getNazev();
			    if ($pol->getOd() && $pol->getDo()) {
			    	$polozka .= " (".date('d.m.Y',strtotime($pol->getOd()))." - ";
			    	$polozka .= date('d.m.Y',strtotime($pol->getDo())).")";
			    }
			    else if ($pol->getOd()) {
			    	$polozka .= " (od ".date('d.m.Y',strtotime($pol->getOd())).")";
				}
			    else if ($pol->getDo()) {
			    	$polozka .= " (do ".date('d.m.Y',strtotime($pol->getDo())).")";
				}
			    $this->Cell(135,3,iconv('utf-8', 'windows-1250', $polozka),0,1,'L'); 
			    $this->Cell(100,6,"",0,0,'L');
			    
			    $this->Cell(10,5,($pol->getKs() != 0 && !is_null($pol->getKs()) ? number_format($pol->getCenaBezDph(),2,',','.')." ".iconv('utf-8', 'windows-1250', $this->getFaktura()->getMena()) : "   "),0,0,'R'); 
			    $this->Cell(8,5,"    ",0,0,'L'); 
			    $this->Cell(8,5,($pol->getKs() != 0 && !is_null($pol->getKs()) ? $pol->getKs()." ks" : "   ")."    ",0,0,'R'); 
			    $this->Cell(12,5,"   ",0,0,'L'); 
			    $this->Cell(10,5, number_format($pol->getCenaCelkemBezDph(),2,',','.')." ".iconv('utf-8', 'windows-1250', $this->getFaktura()->getMena()),0,0,'R'); 
			    $this->Cell(8,5,"    ",0,0,'L'); 
			    $this->Cell(10,5, $pol->getDph()." %      ",0,0,'R'); 
			    $this->Cell(5,5,"   ",0,0,'L'); 
			    $this->Cell(20,5,number_format($pol->getCenaCelkemVcetneDph(),2,',','.')." ".iconv('utf-8', 'windows-1250', $this->getFaktura()->getMena())."       ",0,1,'R');
			      
			    $this->Cell(2,2,"",0,1,'L');   
			}
		    $this->Cell(190,3,"",0,1,'L');
	
	}
	
	public function writePolozkyNeplatce() {
		 
		$hlavickaKusy = false;   
		foreach ($this->getFaktura()->getPolozky() as $pol) {  
			if ($pol->getKs() != 0 && !is_null($pol->getKs())) {
				$hlavickaKusy = true;
				break;
			}
		}   
		
		//polozky faktury
		//hlavicka
		    $this->Cell(3,8,"",TB,0,'L');
		    $this->SetFont('arialbd', '', '8');
		    $this->Cell(90,8,"Poloky",TB,0,'L');
		    $this->Cell(20,8,"",TB,0,'L');        
		    $this->Cell(20,8,"      ",TB,0,'L'); 
		    $this->Cell(10,8,$hlavickaKusy ? "Jedn.cena" : "",TB,0,'L'); 
		    $this->Cell(10,8,"    ",TB,0,'L'); 
		    $this->Cell(10,8,$hlavickaKusy ? "Poet MJ  " : "",TB,0,'L'); 
		    $this->Cell(4,8,"   ",TB,0,'L'); 
		    $this->Cell(23,8,"Celk.cena ",TB,1,'C'); 
		    $this->Cell(190,3,"",0,1,'L');
		
		//data
		    $this->SetFont('arial', '', '8');	
			foreach ($this->getFaktura()->getPolozky() as $pol) {    
			    $this->Cell(3,6,"",0,0,'L');
			    $polozka = $pol->getPolozka()->getNazev();
			    if ($pol->getOd() && $pol->getDo()) {
			    	$polozka .= " (".date('d.m.Y',strtotime($pol->getOd()))." - ";
			    	$polozka .= date('d.m.Y',strtotime($pol->getDo())).")";
			    }
			    else if ($pol->getOd()) {
			    	$polozka .= " (od ".date('d.m.Y',strtotime($pol->getOd())).")";
				}
			    else if ($pol->getDo()) {
			    	$polozka .= " (do ".date('d.m.Y',strtotime($pol->getDo())).")";
				}
			    $this->Cell(135,6,iconv('utf-8', 'windows-1250', $polozka),0,0,'L'); 
			    $this->Cell(10,6,($pol->getKs() != 0 && !is_null($pol->getKs()) ? number_format($pol->getCena(),2,',','.')." ".iconv('utf-8', 'windows-1250', $this->getFaktura()->getMena()) : "   "),0,0,'R'); 
			    $this->Cell(8,6,"    ",0,0,'L'); 
			    $this->Cell(10,6,($pol->getKs() != 0 && !is_null($pol->getKs()) ? $pol->getKs()." ks" : "   ")."  ",0,0,'L'); 
			    $this->Cell(5,6,"   ",0,0,'L'); 
			    $this->Cell(20,6,number_format($pol->getCenaCelkem(),2,',','.')." ".iconv('utf-8', 'windows-1250', $this->getFaktura()->getMena())."       ",0,1,'R');
			}
		    $this->Cell(190,3,"",0,1,'L');
	}
	
	
	
	
	public function getFaktura() {
		return $this->faktura;
	}
	public function setFaktura(Faktura $faktura) {
		$this->faktura = $faktura;
	}
}			
			
?>