<?php
/**
 * Nacitani konfigurace, trid, knihoven, atd.
 */
require_once '../include/app_top.php';

$login = new Login();
$smarty = new WebSmarty();
// pokud neni prihlasen, presmeruje na prihlaseni
require_once '_logged.php';

header("Expires: 0");
header("Pragma: no-cache");
header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");

if ($_GET['id'] ==  'nahled' && $login->opravneni==1) {
	$adminKontakt = DB_KontaktMapper::getAdminKontakt();
	if ($adminKontakt instanceof Kontakt)
		$_POST['dodavatel'] = $adminKontakt->getId();
	else {
		echo "CHYBA: Nejprve musite ulozit fakturacni udaje firmy.";
		exit;
	}
	if ($_POST['nazev']) {
		$_POST['odberatel'] = $_POST['dodavatel'];
	}
	else $_POST['odberatel'] = $_POST['kontakt_id'];
	$mena = DB_MenaMapper::getInstanceByKod($_POST['mena']);
	$_POST['mena_id'] = $mena->getId();
	$faktura = DB_FakturaMapper::getInstanceFromResultRow($_POST);	
	if ($_POST['nazev']) {
		$faktura->setOdberatel(DB_KontaktMapper::getInstanceFromResultRow($_POST));
	}
	$faktura->setDatumVystaveni(($_POST['datum_vystaveni'] ? date('Y-m-d',strtotime($_POST['datum_vystaveni'])) : date('Y-m-d')));
	$faktura->setRazitko(DB_ObrazekFakturaMapper::getAktualni());
	$faktura->setLogo(DB_ObrazekFakturaMapper::getAktualni(false,'logo'));
	$faktura->setPaticka(DB_PatickaMapper::getAktivni());
	
	$ucty = DB_BankovniUcetMapper::getAktivni();
	$ucet = ($ucty ? $ucty[0] : null);
	$faktura->setBankovniUcet($ucet);
	$faktura->setBankovniUcty($ucty);
	
	if (GlobalSettings::$system->getPlatceDph()) {
		$faktura->setPlatceDph(1);
		$faktura->setSazbyDph(DB_SazbaDphMapper::getAll());
	}

	$faktura->setCisloFaktury(($_POST['cislo_faktury'] ? $_POST['cislo_faktury'] : ($_POST['is_proforma'] == 1 ? DB_FakturaMapper::getNewProformaNumber()  : DB_FakturaMapper::getNewNumber() )));
	
	
	if (!empty($_POST['vs']) && $_POST['vs'] != 'automaticky') $vs = trim($_POST['vs']);
	else $vs = preg_replace('/[^0-9]*/','',$faktura->getCisloFaktury());	
	$faktura->setVS($vs);
	
	$platba = intval($_POST['platba']);	
	if ($platba==0) {
		$doklad = ($_POST['cislo_dokladu'] ? $_POST['cislo_dokladu'] : DB_FakturaMapper::getNewDokladNumber());
		$faktura->setDoklad($doklad);
	}

	$polozky = array();
	if (isset($_POST['polozka'])) {
		foreach ($_POST['polozka'] as $i => $pol) {
			if (empty($_POST['polozka'][$i])) continue;
			$od = empty($_POST['od'][$i]) ? null : $_POST['od'][$i];
			$do = empty($_POST['do'][$i]) ? null : $_POST['do'][$i];
			$ks = empty($_POST['ks'][$i]) ? null : $_POST['ks'][$i];
			$dphS = DB_SazbaDphMapper::getByDbString($_POST['dph'][$i]);
			$dph = ($dphS instanceof SazbaDph ? $dphS->getSazba() : 0);
			$castka = floatval($_POST['castka'][$i]);
			if (isset($_POST['castka_bez_dph'][$i])) $castka = floatval($_POST['castka_bez_dph'][$i]);
			$p = new PolozkaFaktura(new Polozka(trim($_POST['polozka'][$i])), $castka, $od, $do, $ks, $faktura);
			$p->setDph($dph);
			$p->setSazbaDph($dphS);
			$polozky[] = $p;
		}
	}	
	$faktura->setPolozkyTmp($polozky);
	$faktura->output();
}
// nejedna se o nahled
else {

	// zobrazit fakturu nebo ji stahnout
	if ($login->is_logged==1) {
		$faktura = DB_FakturaMapper::getInstanceById(intval($_GET['id']));
		
		if ($faktura instanceof Faktura && ($faktura->getUzivatel()==$login->id_user || $login->opravneni==1)) {
			$br = false; $bl = false;
			if ($_GET['br']==1 && $login->opravneni==1) $br = true;
			if ($_GET['bl']==1 && $login->opravneni==1) $bl = true;
			$send['bl'] = $bl;
			$send['br'] = $br;
			$faktura->output($send,($_GET['down']==1 ? "D" : "I"));
		}
		else {
			echo "Neopravneny pristup!";
			exit;
		}
	}
}


?>